#brailleDisplayDrivers/brltty_auto.py
#A part of NonVisual Desktop Access (NVDA)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.
#Copyright 2013 World Light Information Limited and Hong Kong Blind Union.

import _winreg
from subprocess import Popen
#try:
#	import brltty
#except ImportError:
#	pass
import brltty

class BrailleDisplayDriver(brltty.BrailleDisplayDriver):
	"""brltty braille display driver with automatic start/stop of service
	"""
	name = "brltty_auto"
	description = "brltty_auto"
	installPath = None

	@classmethod
	def check(cls):
		return brltty.BrailleDisplayDriver.check()

	def __init__(self):
		try:
			key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, "SOFTWARE\\BRLTTY")
			self.installPath = _winreg.QueryValueEx(key, None)[0]
		except:
			self.installPath = None
		if not self.installPath==None:
			try:
				Popen(("%s\\%s"%(self.installPath,"install.bat")),cwd=self.installPath)
			except:
				pass
		super(BrailleDisplayDriver, self).__init__()

	def terminate(self):
		super(BrailleDisplayDriver, self).terminate()
		if not self.installPath==None:
			try:
				Popen(("%s\\%s"%(self.installPath,"uninstall.bat")),cwd=self.installPath)

			except:
				pass
